- Qt 6.8
- Qt 3D
- C++ Classes
- Qt3DExtras (Deprecated)
- QTorusGeometry
- Qt 6.8.2 Reference Documentation

# QTorusGeometry Class

class Qt3DExtras::QTorusGeometry

The QTorusGeometry class allows creation of a torus in 3D space. More...

Header: | `#include <Qt3DExtras/QTorusGeometry>`
CMake: | `find_package(Qt6 REQUIRED COMPONENTS 3dextras)` `target_link_libraries(mytarget PRIVATE Qt6::3dextras)`
qmake: | `QT += 3dextras`
In QML: | TorusGeometry
Inherits: | Qt3DCore::QGeometry
Status: | Deprecated

- List of all members, including inherited members

## Properties

indexAttribute : Qt3DCore::QAttribute* const minorRadius : float normalAttribute : Qt3DCore::QAttribute* const positionAttribute : Qt3DCore::QAttribute* const | radius : float rings : int slices : int texCoordAttribute : Qt3DCore::QAttribute* const

## Public Functions

| QTorusGeometry(Qt3DCore::QNode *parent = nullptr)
Qt3DCore::QAttribute * | indexAttribute() const
float | minorRadius() const
Qt3DCore::QAttribute * | normalAttribute() const
Qt3DCore::QAttribute * | positionAttribute() const
float | radius() const
int | rings() const
int | slices() const
Qt3DCore::QAttribute * | texCoordAttribute() const
void | updateIndices()
void | updateVertices()

## Public Slots

void | setMinorRadius(float minorRadius)
void | setRadius(float radius)
void | setRings(int rings)
void | setSlices(int slices)

## Signals

void | minorRadiusChanged(float minorRadius)
void | radiusChanged(float radius)
void | ringsChanged(int rings)
void | slicesChanged(int slices)

## Detailed Description

The QTorusGeometry class is most commonly used internally by the QTorusMesh but can also be used in custom Qt3DRender::QGeometryRenderer subclasses.

## Property Documentation

### `[read-only]` indexAttribute : Qt3DCore::QAttribute* const

Holds the geometry index attribute.

Access functions:

Qt3DCore::QAttribute * | indexAttribute() const

### minorRadius : float

Holds the inner radius of the torus.

Access functions:

float | minorRadius() const
void | setMinorRadius(float minorRadius)

Notifier signal:

void | minorRadiusChanged(float minorRadius)

### `[read-only]` normalAttribute : Qt3DCore::QAttribute* const

Holds the geometry normal attribute.

Access functions:

Qt3DCore::QAttribute * | normalAttribute() const

### `[read-only]` positionAttribute : Qt3DCore::QAttribute* const

Holds the geometry position attribute.

Access functions:

Qt3DCore::QAttribute * | positionAttribute() const

### radius : float

Holds the outer radius of the torus.

Access functions:

float | radius() const
void | setRadius(float radius)

Notifier signal:

void | radiusChanged(float radius)

### rings : int

Holds the number of rings in the torus.

Access functions:

int | rings() const
void | setRings(int rings)

Notifier signal:

void | ringsChanged(int rings)

### slices : int

Holds the number of slices in the torus.

Access functions:

int | slices() const
void | setSlices(int slices)

Notifier signal:

void | slicesChanged(int slices)

### `[read-only]` texCoordAttribute : Qt3DCore::QAttribute* const

Holds the geometry texture coordinate attribute.

Access functions:

Qt3DCore::QAttribute * | texCoordAttribute() const

## Member Function Documentation

### `[explicit]` QTorusGeometry::QTorusGeometry(Qt3DCore::QNode *parent = nullptr)

Constructs a new QTorusGeometry with parent.

### void QTorusGeometry::updateIndices()

Updates indices based on rings and slices properties.

### void QTorusGeometry::updateVertices()

Updates vertices based on rings, slices, and radius properties.